<?php

namespace Drupal\simple_trash_node;

use Drupal\Core\Access\AccessResult;
use Drupal\Core\Entity\EntityInterface;
use Drupal\Core\Session\AccountInterface;

class TrashNodeAccessControlHandler extends \Drupal\node\NodeAccessControlHandler
{
  public function access(EntityInterface $entity, $operation, AccountInterface $account = NULL, $return_as_object = FALSE) {
    if (!empty($entity->trash->value)) {
      $result = AccessResult::forbidden()->addCacheableDependency($entity);
      return $return_as_object ? $result : $result->isAllowed();
    }
    $result = parent::access($entity, $operation, $account, TRUE);
    assert($result instanceof AccessResult);
    $result->cachePerPermissions();

    return $return_as_object ? $result : $result->isAllowed();
  }
}
