<?php

namespace Drupal\simple_trash_node;

use Drupal\node\NodeStorage;

/**
 * Defines the storage handler class for nodes.
 *
 * This extends the base storage class, adding required special handling for
 * node entities.
 */
class TrashNodeStorage extends NodeStorage {

  /**
   * {@inheritdoc}
   */
  public function delete(array $entities, bool $permanent_delete = false) {
    if (!$permanent_delete) {
      if (!$entities) {
        // If no entities were passed, do nothing.
        return;
      }
      foreach ($entities as $key => $entity) {
        $bundle = \Drupal::entityTypeManager()->getStorage('node_type')->load($entity->bundle());
        $simple_trash_enable = $bundle->getThirdPartySetting('simple_trash', 'simple_trash_enable');
        if (!empty($simple_trash_enable)) {
          $entity->set('trash', 1);
          $entity->save();
        }
        unset($entities[$key]);
      }
    }
    parent::delete($entities);
  }

}
